org.codehaus.plexus.compiler.javac

## Class JavacCompiler

- java.lang.Object
- - org.codehaus.plexus.logging.AbstractLogEnabled
  - - org.codehaus.plexus.compiler.AbstractCompiler
    - - org.codehaus.plexus.compiler.javac.JavacCompiler

All Implemented Interfaces:
  Compiler, org.codehaus.plexus.logging.LogEnabled

    public class JavacCompiler
    extends AbstractCompiler

Version:
  $Id$
Author:
  Trygve Laugstøl, Matthew Pocock, Jörg Waßmer, Others

### Field Summary

### Fields inherited from class org.codehaus.plexus.compiler.AbstractCompiler

`EOL, PS`

### Fields inherited from interface org.codehaus.plexus.compiler.Compiler

`ROLE`

### Constructor Summary

Constructors
Constructor and Description
`JavacCompiler()`

### Method Summary

Methods
`static String[]` `buildCompilerArguments(CompilerConfiguration config, String[] sourceFiles)`
`List<CompilerError>` `compile(CompilerConfiguration config)`
`String[]` `createCommandLine(CompilerConfiguration config)` Create the command line that would be executed using this configuration.
`protected static List<CompilerError>` `parseModernStream(BufferedReader input)`

### Methods inherited from class org.codehaus.plexus.compiler.AbstractCompiler

`canUpdateTarget, getCompilerOutputStyle, getInputFileEnding, getOutputFile, getOutputFileEnding, getPathString, getSourceFiles, getSourceFilesForSourceRoot, makeClassName, toStringArray`

### Methods inherited from class org.codehaus.plexus.logging.AbstractLogEnabled

`enableLogging, getLogger, setupLogger, setupLogger, setupLogger`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Constructor Detail

#### JavacCompiler

    public JavacCompiler()

### Method Detail

#### compile

    public List<CompilerError> compile(CompilerConfiguration config)
                                throws CompilerException

Throws:
  `CompilerException`

#### createCommandLine

    public String[] createCommandLine(CompilerConfiguration config)
                               throws CompilerException

Description copied from interface: `Compiler`
Create the command line that would be executed using this configuration. If this particular compiler has no concept of a command line then returns null.

Parameters:
  `config` - the CompilerConfiguration describing the compilation
Returns:
  an array of Strings that make up the command line, or null if this compiler has no concept of command line
Throws:
  `CompilerException` - if there was an error generating the command line

#### buildCompilerArguments

    public static String[] buildCompilerArguments(CompilerConfiguration config,
                                  String[] sourceFiles)

#### parseModernStream

    protected static List<CompilerError> parseModernStream(BufferedReader input)
                                                    throws IOException

Throws:
  `IOException`